package net.lenharts.gwt.sampleiphoneapp.client.model;

import java.util.ArrayList;

import com.google.gwt.xml.client.Document;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.Node;
import com.google.gwt.xml.client.NodeList;
import com.google.gwt.xml.client.XMLParser;

public class GroupPage implements IPage {

	private ArrayList<Team> mTeams = new ArrayList<Team>();
	private String mName;
	private String mTournamentName;

	private GroupPage() {

	}

	public static GroupPage convert(String messageXml, String tournamentName) {

		// parse the XML document into a DOM
		Document messageDom = XMLParser.parse(messageXml);

		GroupPage result = new GroupPage();

		Element topGroup = messageDom.getDocumentElement();
		result.mName = topGroup.getAttribute("name");
		result.mTournamentName = tournamentName;

		NodeList teamList = topGroup.getChildNodes();
		for (int i = 0; i < teamList.getLength(); i++) {
			Node node = teamList.item(i);
			if (node.getNodeName().equals("item")) {
				Element teamElement = (Element) node;

				result.mTeams.add(result.new Team(teamElement
						.getAttribute("name")));
			}
		}

		return result;

	}

	@Override
	public String getBackButtonText() {
		return mTournamentName;
	}

	@Override
	public String getTitle() {
		return mName;
	}

	public Iterable<Team> getTeams() {
		return mTeams;
	}

	public class Team {

		private String mName;

		public Team(String name) {
			mName = name;
		}

		public String getName() {
			return mName;
		}

	}
}
