package net.lenharts.gwt.sampleiphoneapp.client.model;

import java.util.ArrayList;
import com.google.gwt.xml.client.DOMException;
import com.google.gwt.xml.client.Document;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.NodeList;
import com.google.gwt.xml.client.XMLParser;
import com.google.gwt.xml.client.Node;

public class MainPage implements IPage {

	private MainPage() {

	}

	public static MainPage convert(String messageXml) throws DOMException {

		// parse the XML document into a DOM
		Document messageDom = XMLParser.parse(messageXml);

		MainPage result = new MainPage();

		Node catalog = messageDom.getElementsByTagName("catalog").item(0);

		NodeList groupList = catalog.getChildNodes();
		for (int i = 0; i < groupList.getLength(); i++) {
			Node groupNode = groupList.item(i);
			if (groupNode.getNodeName().equals("group")) {
				Element groupElement = (Element) groupNode;

				result.mTournaments.add(result.new Tournament(groupElement
						.getAttribute("name"), groupElement
						.getAttribute("href")));
			}
		}

		return result;

	}

	public class Tournament {
		private String mName;
		private String mRelativeUrl;

		public Tournament(String name, String relativeUrl) {
			mName = name;
			mRelativeUrl = relativeUrl;
		}

		public String getName() {
			return mName;
		}

		public String getRelativeUrl() {
			return mRelativeUrl;
		}
	}

	private ArrayList<Tournament> mTournaments = new ArrayList<Tournament>();

	public Iterable<Tournament> getTournaments() {
		return mTournaments;
	}

	@Override
	public String getBackButtonText() {
		return null;
	}

	@Override
	public String getTitle() {
		return "GWT Euro Championships";
	}

}
