package net.lenharts.gwt.sampleiphoneapp.client.model;

import java.util.ArrayList;

import com.google.gwt.xml.client.Document;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.Node;
import com.google.gwt.xml.client.NodeList;
import com.google.gwt.xml.client.XMLParser;

public class TournamentPage implements IPage {

	private ArrayList<Group> mGroups = new ArrayList<Group>();
	private String mWinner;
	private String mName;

	private TournamentPage() {

	}

	public static TournamentPage convert(String messageXml) {

		// parse the XML document into a DOM
		Document messageDom = XMLParser.parse(messageXml);

		TournamentPage result = new TournamentPage();

		Element topGroup = messageDom.getDocumentElement();
		result.mName = topGroup.getAttribute("name");

		NodeList groupList = topGroup.getChildNodes();
		for (int i = 0; i < groupList.getLength(); i++) {
			Node node = groupList.item(i);
			if (node.getNodeName().equals("group")) {
				Element groupElement = (Element) node;

				result.mGroups.add(result.new Group(groupElement
						.getAttribute("name"), groupElement
						.getAttribute("href")));
			} else if (node.getNodeName().equals("item")) {
				Element itemElement = (Element) node;

				result.mWinner = itemElement.getAttribute("name");
			}
		}

		return result;

	}

	@Override
	public String getBackButtonText() {
		return "GWT Euro Championships";
	}

	@Override
	public String getTitle() {
		return mName;
	}

	public Iterable<Group> getGroups() {
		return mGroups;
	}

	public String getWinner() {
		return mWinner;
	}

	public class Group {

		private String mName;
		private String mRelativeUrl;

		public Group(String name, String relativeUrl) {
			mName = name;
			mRelativeUrl = relativeUrl;
		}

		public String getName() {
			return mName;
		}

		public String getRelativeUrl() {
			return mRelativeUrl;
		}
	}
}
