package net.lenharts.gwt.sampleiphoneapp.client.view;

import net.lenharts.gwt.sampleiphoneapp.client.Controller;
import net.lenharts.gwt.sampleiphoneapp.client.model.MainPage;
import net.lenharts.gwt.sampleiphoneapp.client.util.GenericContainerTag;
import net.lenharts.gwt.sampleiphoneapp.client.util.GenericTextTag;
import net.lenharts.gwt.sampleiphoneapp.client.util.TouchClickEvent;
import com.google.gwt.user.client.ui.FlowPanel;

public class MainPagePanel extends AbstractPagePanel {

	private MainPage mMainPage;

	public MainPagePanel(MainPage mainPage) {

		FlowPanel basePanel = new FlowPanel();
		// basePanel.setStyleName("page");

		mMainPage = mainPage;

		GenericContainerTag ul = new GenericContainerTag("ul");
		basePanel.add(ul);

		for (MainPage.Tournament tournament : mMainPage.getTournaments()) {
			GenericTextTag<String> li = new GenericTextTag<String>("li",
					tournament.getName());
			li.setAttachedInfo(tournament.getRelativeUrl());

			li.addHandler(new TouchClickEvent.TouchClickHandler<String>() {
				@Override
				public void touchClick(TouchClickEvent<String> e) {
					// attachedInfo is the relative URL
					if (!ViewSettings.AnimationRunning) {
						Controller.navigateToTournament(e.getTarget()
								.getAttachedInfo(), mMainPage);
					}
				}
			});
			li.setStyleName("group");

			ul.add(li);
		}

		initWidget(basePanel);
	}

}
