package net.lenharts.gwt.sampleiphoneapp.client.view;

import net.lenharts.gwt.sampleiphoneapp.client.model.GroupPage;
import net.lenharts.gwt.sampleiphoneapp.client.model.IPage;
import net.lenharts.gwt.sampleiphoneapp.client.model.InfiniteDepthPage;
import net.lenharts.gwt.sampleiphoneapp.client.model.MainPage;
import net.lenharts.gwt.sampleiphoneapp.client.model.TournamentPage;

public class PagePanelFactory {

	private PagePanelFactory() {

	}

	public static AbstractPagePanel createPagePanel(IPage page) {
		if (page instanceof MainPage) {
			return new MainPagePanel((MainPage) page);
		} else if (page instanceof TournamentPage) {
			return new TournamentPagePanel((TournamentPage) page);
		} else if (page instanceof GroupPage) {
			return new GroupPagePanel((GroupPage) page);
		} else if (page instanceof InfiniteDepthPage) {
			return new InfiniteDepthPagePanel((InfiniteDepthPage) page);
		}
		throw new IllegalArgumentException("The page is unknown:"
				+ page.getClass().getName());
	}
}
