package net.lenharts.gwt.sampleiphoneapp.client.view;

import net.lenharts.gwt.sampleiphoneapp.client.Controller;
import net.lenharts.gwt.sampleiphoneapp.client.model.TournamentPage;
import net.lenharts.gwt.sampleiphoneapp.client.util.GenericContainerTag;
import net.lenharts.gwt.sampleiphoneapp.client.util.GenericTextTag;
import net.lenharts.gwt.sampleiphoneapp.client.util.TouchClickEvent;

import com.google.gwt.user.client.ui.FlowPanel;

public class TournamentPagePanel extends AbstractPagePanel {

	private TournamentPage mTournamentPage;

	public TournamentPagePanel(TournamentPage tournamentPage) {

		FlowPanel basePanel = new FlowPanel();
		// basePanel.setStyleName("page");

		mTournamentPage = tournamentPage;

		GenericContainerTag ul = new GenericContainerTag("ul");
		basePanel.add(ul);

		GenericTextTag<String> li1 = new GenericTextTag<String>("li",
				tournamentPage.getWinner());
		li1.setStyleName("item");
		ul.add(li1);

		for (TournamentPage.Group group : mTournamentPage.getGroups()) {
			GenericTextTag<String> li = new GenericTextTag<String>("li", group
					.getName());
			li.setAttachedInfo(group.getRelativeUrl());

			li.addHandler(new TouchClickEvent.TouchClickHandler<String>() {
				@Override
				public void touchClick(TouchClickEvent<String> e) {
					// attachedInfo is the relative URL
					if (!ViewSettings.AnimationRunning) {
						Controller.navigateToGroup(e.getTarget()
								.getAttachedInfo(), mTournamentPage);
					}
				}
			});
			li.setStyleName("group");

			ul.add(li);
		}

		initWidget(basePanel);
	}

}